Subject: Re: [regression] 2.6.39-rc[1-3] fail to boot on G5 PowerMac

From: Jens Axboe <[email-masked]>
Date: Sun, 17 Apr 2011 09:00:17 +0200

On 2011-04-17 05:16, Hugh Dickins wrote:
> On Thu, Apr 14, 2011 at 2:54 PM, Benjamin Herrenschmidt
> <[email-masked]> wrote:
>> On Thu, 2011-04-14 at 14:25 -0700, Hugh Dickins wrote:
>>>
>>> Something worth trying: turn off CONFIG_IDE.  That's what I need to
>>> boot 2.6.39-rc[1-3] on PowerPC G5.
>>>
>>> I know Jens has been fixing problems with IDE versus his plug/unplug
>>> changes, but it's still not fixed for me in rc3.
>>>
>>> In other mail http://lkml.org/lkml/2011/4/14/614
>>> I see Linus recommending his post-rc3 commit 6631e635c65d
>>> but I've not tried that myself yet.
>>
>> Well, the disk is SATA so it's CONFIG_ATA/libata, which works fine here,
>> unless you somewhat replaced your CD-ROM with a legacy IDE disk :-) Or
>> maybe the problem is related to the CD-ROM drive. There's a libata
>> driver for it nowadays, so you can use PATA_MACIO instead of IDE_PMAC
> 
> Thanks for that, Ben: I remember you were brewing up such a driver,
> but I missed when it actually went in.  I can confirm that switching
> off CONFIG_IDE and switching on CONFIG_PATA_MACIO and
> CONFIG_BLK_DEV_SR now gives me a booting system with a working CD-ROM
> (though I've not yet tried burning).
> 
> Whereas CONFIG_IDE=y with current git still does not boot: hangs for a
> minute or three around the windfarm announcements, then an endless
> splurge of hda error messages - sorry, I'm not being helpful, other
> worries...

It's the media event notification that goes crazy. Try and comment out
this line:

	drive->dev_flags |= IDE_DFLAG_MEDIA_CHANGED;

in drivers/ide/ide-cd.c:cdrom_saw_media_change() and see if it boots.

-- 
Jens Axboe